﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Esempio3
{
    delegate int Azione(int param);

    class Program
    {
        static void Main(string[] args)
        {
            Step1a();
            //Step1b();
            //Step1c();
            //Step2();
            //Step3();
            //Step4();
            //Step5();
            //Step6();
        }

        #region Step1

        private static void Step1a()
        {
            Azione azione;
            azione = new Azione(Raddoppia);
            Console.WriteLine("Risultato: {0}", azione(10));
            azione = new Azione(Dimezza);
            Console.WriteLine("Risultato: {0}", azione(10));
            //  Del tutto equivalente a:
            Console.WriteLine("Risultato: {0}", Raddoppia(10));
            Console.WriteLine("Risultato: {0}", Dimezza(10));
        }

        private static void Step1b()
        {
            Go(new Azione(Raddoppia));
            Go(new Azione(Dimezza));
            //  Si può anche scrivere (C# 2.0)
            Go(Raddoppia);
            Go(Dimezza);
        }

        private static void Step1c()
        {
            Factor factor = new Factor(5);
            Go(Raddoppia);
            Go(Dimezza);
            Go(factor.Moltiplica);
            Go(factor.Dividi);
        }

        private static int Raddoppia(int x)
        {
            return x * 2;
        }

        private static int Dimezza(int x)
        {
            return x / 2;
        }

        private static void Go(Azione azione)
        {
            Console.WriteLine("Risultato: {0}", azione(10));
        }

        #endregion

        #region Step2

        private static void Step2()
        {
            Azione azione;
            azione = Fun1;
            azione(10);
            Console.WriteLine("-----------------");
            azione += Fun2;
            azione(20);
            Console.WriteLine("-----------------");
            azione += Fun1;
            azione(30);
            Console.WriteLine("-----------------");
            azione -= Fun1;
            azione(40);
            Console.WriteLine("-----------------");
            azione -= Fun1;
            azione(50);
            Console.WriteLine("-----------------");
            azione -= Fun1;  //  Nop
            azione(60);
            Console.WriteLine("-----------------");
        }

        private static int Fun1(int x)
        {
            Console.WriteLine("Valore di x: {0}", x);
            return x;
        }

        private static int Fun2(int y)
        {
            Console.WriteLine("Valore di y: {0}", y);
            return y;
        }

        #endregion

        #region Step3

        delegate string Azione3(ref string param);

        private static void Step3()
        {
            Azione3 azione = ToUpper;
            azione += TrimStart;
            azione += TrimEnd;

            string s1 = "  abcdefghijk  ";
            Console.WriteLine("s1: \"" + s1 + "\"");
            Console.WriteLine("s1a: \"" + azione(ref s1) + "\"");
            Console.WriteLine("s1b: \"" + s1 + "\"");
        }

        static string ToUpper(ref string str)
        {
            str = str.ToUpper(); return str;
        }

        static string TrimEnd(ref string str)
        {
            str = str.TrimEnd(); return str;
        }

        static string TrimStart(ref string str)
        {
            str = str.TrimStart(); return str;
        }

        #endregion

        #region Step4

        private static void Step4()
        {
            Azione3 azione = ToUpper;
            azione += TrimStart;
            azione += TrimEnd;

            foreach (Azione3 a in azione.GetInvocationList())
                Console.WriteLine(a.Method.Name);
            Console.WriteLine("-----------------");

            foreach (Azione3 a in azione.GetInvocationList())
                Console.WriteLine(a.Method.ToString());
            Console.WriteLine("-----------------");

            string s1 = "  abcdefghijk  ";
            Console.WriteLine("s1: \"" + s1 + "\"");
            foreach (Azione3 a in azione.GetInvocationList())
            {
                Console.WriteLine(a.Method.Name);
                Console.WriteLine("s1a: \"" + a(ref s1) + "\"");
                Console.WriteLine("s1b: \"" + s1 + "\"");
            }
            Console.WriteLine("-----------------");
        }

        #endregion

        #region Step5

        delegate void TestDelegate(string s);

        private static void Step5()
        {
            TestDelegate testDelegateA = new TestDelegate(Console.WriteLine);

            //  C# 2.0

            TestDelegate testDelegateB = Console.WriteLine;
            //  Anonymous method
            TestDelegate testDelegateC = delegate(string s) { Console.WriteLine(s); };

            // C# 3.0

            // Lambda expression
            TestDelegate testDelegateD1 = (string s) => { Console.WriteLine(s); };
            // The type of s is inferred by the compiler
            TestDelegate testDelegateD2 = (s) => { Console.WriteLine(s); };
            TestDelegate testDelegateD3 = s => { Console.WriteLine(s); };

            // Invoke the delegates.
            testDelegateA("TestDelegate testDelegateA = new TestDelegate(Console.WriteLine);");
            testDelegateB("TestDelegate testDelegateB = Console.WriteLine;");
            testDelegateC("TestDelegate testDelegateC = delegate(string s) { Console.WriteLine(s); };");
            testDelegateD1("TestDelegate testDelegateD1 = (string s) => { Console.WriteLine(s); };");
            testDelegateD2("TestDelegate testDelegateD2 = (s) => { Console.WriteLine(s); };");
            testDelegateD3("TestDelegate testDelegateD3 = s => { Console.WriteLine(s); };");
        }

        #endregion

        #region Step6

        private static void Step6()
        {
            string[] colors = Enum.GetNames(typeof(Color));
            Display(colors);

            Array.Sort(colors);
            Display(colors);

            //Array.Sort(colors, delegate(string color1, string color2) { return (color2.CompareTo(color1)); });
            //Display(colors);

            //Array.Sort(colors, (string color1, string color2) => { return (color2.CompareTo(color1)); });
            //Display(colors);

            //Array.Sort(colors, (color1, color2) => color2.CompareTo(color1));
            //Display(colors);

            //Array.Sort(colors, (color1, color2) => color1[2].CompareTo(color2[2]));
            //Display(colors);

            //Display(Array.FindAll(colors, color => color[0] == 'B'));

            //Display(colors.Where(color => color[0] == 'B'));

            //IEnumerable<string> result = from color in colors
            //                             where color[0] == 'B'
            //                             select color;
            //Display(result);

            //var result2 = from color in colors
            //              where color[0] == 'B'
            //              select new { Name = color, Value = (int) Enum.Parse(typeof(Color), color) };
            //foreach (object o in result2)
            //    Console.WriteLine(o.ToString());
            //Console.WriteLine("------------");
        }

        private static void Display(IEnumerable<string> args)
        {
            foreach (string arg in args)
                Console.WriteLine(arg);
            Console.WriteLine("------------");
        }

        #endregion
    }
}
